#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.6.1
 Author:         Matwachich

 Script Function:
	GEngin - Drawings

#ce ----------------------------------------------------------------------------

; # FUNCTION # ==============================================================================================
; Name...........:	_GEng_DrawStart
; Description....:	Vide l'cran, et le rempli avec une couleur
; Parameters.....:	$iBufferColor = Coleur avec la quelle remplir l'cran (0xARVB)
;						Par dfaut: Blanc opaque
; Return values..:	Succes: 1
;					Erreur: 0
; Author.........:	Matwachich
; Remarks........:	Il est conceill d'appeler cette fonction avant tout appel  _GEng_SpriteDraw()
; ===========================================================================================================
Func _GEng_DrawStart($iBufferColor = 0xFFFFFFFF)
	If Not _GEng_IsStarted() Then Return SetError(-1, 0, 0)
	; ---
	Return _GDIPlus_GraphicsClear($__GEng_MainArray[3], $iBufferColor)
EndFunc

; # FUNCTION # ==============================================================================================
; Name...........:	_GEng_DrawEnd
; Description....:	Valide les appel  _GEng_SpriteDraw()
; Parameters.....:	Rien
; Return values..:	Succes: 1
;					Erreur: 0
; Author.........:	Matwachich
; Remarks........:	Sans cette fonction, aucun sprite n'est dssin  l'cran
; ===========================================================================================================
Func _GEng_DrawEnd()
	If Not _GEng_IsStarted() Then Return SetError(-1, 0, 0)
	; ---
	Return _GDIPlus_GraphicsDrawImageRect($__GEng_MainArray[1], $__GEng_MainArray[2], 0, 0, $__GEng_MainArray[4], $__GEng_MainArray[5])
EndFunc
