#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.6.1
 Author:         Matwachich

 Script Function:
	GEngin - Images

#ce ----------------------------------------------------------------------------

Global $__GEng_LoadedImg[1] = [0]

; # FUNCTION # ==============================================================================================
; Name...........:	_GEng_ImgLoad
; Description....:	Charge une image pour l'utiliser dans GEngine
; Parameters.....:	$sPath = Chemin vers l'image
; Return values..:	Succes: objet image (diffrent du ImageHandle de _GDIPlus_ImageLoadFromFile)
;					Erreur: -1 et @error
; Author.........:	Matwachich
; Remarks........:	
; ===========================================================================================================
Func _GEng_ImgLoad($sPath)
	If Not _GEng_IsStarted() Then Return SetError(-1, 0, 0)
	; ---
	Local $ret[3]
	Local $hImg = _GDIPlus_ImageLoadFromFile($sPath)
	If @error Then Return SetError(@error, 0, $hImg)
	; ---
	_ArrayAdd($__GEng_LoadedImg, $hImg)
	$__GEng_LoadedImg[0] += 1
	; ---
	$ret[0] = $__GEng_LoadedImg[0]
	$ret[1] = _GDIPlus_ImageGetWidth($hImg)
	$ret[2] = _GDIPlus_ImageGetHeight($hImg)
	; ---
	Return $ret
EndFunc



; ==============================================================
; ### Internals
; ==============================================================
Func __GEng_ImgCleanup()
	For $i = 1 To $__GEng_LoadedImg[0]
		_GDIPlus_ImageDispose($__GEng_LoadedImg[$i])
	Next
EndFunc

Func __GEng_IsImg($hImg)
	__GEng_hImg_GetHandle($hImg)
	If @error Then Return SetError(1, 0, 0)
	Return SetError(0, 0, 1)
EndFunc

Func __GEng_hImg_GetHandle($hImg)
	If UBound($hImg) <> 3 Then Return SetError(1, 0, 0)
	Local $iIndex = $hImg[0]
	If $iIndex > $__GEng_LoadedImg[0] Then Return SetError(2, 0, 0)
	; ---
	Return $__GEng_LoadedImg[$iIndex]
EndFunc

Func __GEng_hImg_GetDimensions($hImg, $dim = "")
	If UBound($hImg) <> 3 Then Return SetError(1, 0, 0)
	Local $iIndex = $hImg[0]
	If $iIndex > $__GEng_LoadedImg[0] Then Return SetError(1, 0, 0)
	; ---
	Switch $dim
		Case "x"
			Return $hImg[1]
		Case "y"
			Return $hImg[2]
		Case Else
			Local $ret[2]
			$ret[0] = $hImg[1]
			$ret[1] = $hImg[2]
			Return $ret
	EndSwitch
EndFunc