#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.6.1
 Author:         Matwachich

 Script Function:
	GEngin - System

#ce ----------------------------------------------------------------------------

Global $__GEng_MainArray[6] = [0,0,0,0,0,0]
Global $__GEng_Started = 0

; # FUNCTION # ==============================================================================================
; Name...........:	_GEng_Start
; Description....:	Dmare GEngine
; Parameters.....:	Idem GuiCreate()
; Return values..:	Idem GuiCreate()
; Author.........:	Matwachich
; Remarks........:	
; ===========================================================================================================
Func _GEng_Start($sTitle, $iW, $iH, $iX = -1, $iY = -1, $iStyle = -1, $iExtStyle = -1)
	Local $hGui = GuiCreate($sTitle, $iW, $iH, $iX, $iY, $iStyle, $iExtStyle)
	If @error Then Return SetError(@error, 0, 0)
	; ---
	_GDIPlus_Startup()
	; DEBUG 
	If $__GEng_Debug Then
		$_dbg_pen1 = _GDIPlus_PenCreate(0xFFFF0000, 2)
		$_dbg_pen2 = _GDIPlus_PenCreate(0xFF00FF00, 2)
		$_dbg_pen3 = _GDIPlus_PenCreate(0xFF0000FF, 2)
	EndIf
	; ---
	Local $hGraphic = _GDIPlus_GraphicsCreateFromHWND($hGui)
	Local $hBitmap = _GDIPlus_BitmapCreateFromGraphics($iW, $iH, $hGraphic)
	Local $hBuffer = _GDIPlus_ImageGetGraphicsContext($hBitmap)
	; ---
	_GDIPlus_GraphicsSetSmoothingMode($hBuffer, 2)
	; ---
	$__GEng_MainArray[0] = $hGui
	$__GEng_MainArray[1] = $hGraphic
	$__GEng_MainArray[2] = $hBitmap
	$__GEng_MainArray[3] = $hBuffer
	$__GEng_MainArray[4] = $iW
	$__GEng_MainArray[5] = $iH
	; ---	
	$__GEng_Started = 1
	; ---
	GuiSetState(@SW_SHOW, $hGui)
	Return SetError(0, 0, 1)
EndFunc

Func _GEng_IsStarted()
	Return $__GEng_Started
EndFunc

Func _GEng_WinGetInfo($iInfo = 0)
	Switch $iInfo
		Case 0 ; Gui Handle
			Return $__GEng_MainArray[0]
		Case 1 ; Width
			Return $__GEng_MainArray[4]
		Case 2 ; Height
			Return $__GEng_MainArray[5]
		Case Else
			Return SetError(1, 0, 0)
	EndSwitch
EndFunc

; # FUNCTION # ==============================================================================================
; Name...........:	_GEng_Shutdown
; Description....:	Stop GEngin et libre toutes les ressources
; Parameters.....:	Rien
; Return values..:	1
; Author.........:	Matwachich
; Remarks........:	
; ===========================================================================================================
Func _GEng_Shutdown()
	__GEng_ImgCleanup()
	; ---
	; DEBUG
	If $__GEng_Debug Then
		_GDIPlus_PenDispose($_dbg_pen1)
		_GDIPlus_PenDispose($_dbg_pen2)
		_GDIPlus_PenDispose($_dbg_pen3)
	EndIf
	; ---
	_GDIPlus_GraphicsDispose($__GEng_MainArray[3])
	_GDIPlus_BitmapDispose($__GEng_MainArray[2])
	_GDIPlus_GraphicsDispose($__GEng_MainArray[1])
	_GDIPlus_Shutdown()
	GuiDelete($__GEng_MainArray[0])
	Return 1
EndFunc
