#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.6.1
 Author:         Matwachich

 Script Function:


#ce ----------------------------------------------------------------------------
#NoTrayIcon

#include <GEngin.au3>
#include <Misc.au3>

Opt("GuiOnEventMode", 1)
Opt("MouseCoordMode", 2)

_GEng_Start("Mech Test", 600, 400)
GuiSetOnEvent(-3, "_exit")

$User32_dll = DllOpen("user32.dll")
Global $shots[1] = [0]

Dim $img[2]
$img[0] = _GEng_ImgLoad(@ScriptDir & "\m1.png")
$img[1] = _GEng_ImgLoad(@ScriptDir & "\m2.png")
$imgFire = _GEng_ImgLoad(@scriptDir & "\fire.png")
$imgGimp = _GEng_ImgLoad(@scriptDir & "\gimp.png")

$sprMech = _GEng_SpriteCreate()
_GEng_SpriteSetImg($sprMech, $img[0])

Global $nbrHits = 0
$sprMech2 = _GEng_SpriteCreate()
_GEng_SpriteSetImg($sprMech2, $imgGimp)
_GEng_SpriteSet($sprMech2, 400, 200, Default, Default, $GEng_Middle)

Local $i = 0, $mPos, $pos, $size, $origin
$MechAnim_timer = TimerInit()
$Shoot_timer = TimerInit()
While 1
	_GEng_DrawStart(0xFFFFFFFF)
	
	If TimerDiff($MechAnim_timer) >= 150 Then
		If $i = 0 Then
			$i = 1
		Else
			$i = 0
		EndIf
		_GEng_SpriteSetImg($sprMech, $img[$i])
		$MechAnim_timer = TimerInit()
	EndIf
	
	If _IsPressed('01', $User32_dll) Then
		If TimerDiff($Shoot_timer) >= 150 Then
			_Fire()
			$Shoot_timer = TimerInit()
		EndIf
	ElseIf _IsPressed('02', $User32_dll) Then
		$nbrHits = 0
		$sprMech2 = _GEng_SpriteCreate()
		_GEng_SpriteSetImg($sprMech2, $imgGimp)
		_GEng_SpriteSet($sprMech2, 400, 200, Default, Default, $GEng_Middle)
	EndIf
	
	$mPos = MouseGetPos()
	_GEng_SpriteSet($sprMech, $mPos[0], $mPos[1], Default, Default, $GEng_Middle)
	_GEng_SpriteDraw($sprMech)
	
	If $nbrHits < 10 Then
		_GEng_SpriteDraw($sprMech2)
	Else
		$sprMech2 = 0
	EndIf
	
	_CheckFireAnim()
	
	If _GEng_SpriteCollision($sprMech, $sprMech2, 10, 10, 10, 35) Then ConsoleWrite("Collision!" & @CRLF)
	
	_GEng_DrawEnd()
	
	$pos = _GEng_SpriteGetPos($sprMech)
	$size = _GEng_SpriteGetSize($sprMech)
	$origin = _GEng_SpriteGetOrigin($sprMech)
	WinSetTitle(_GEng_WinGetInfo(0), "", "Mech Test - Mech pos: " & $pos[0] & " x " & $pos[1] & " - Size: " & _
										 $size[0] & " x " & $size[1] & " - Origin: " & $origin[0] & " x " & $origin[1])
	
	Sleep(10)
WEnd

Func _Fire()
	Local $mechPos = _GEng_SpriteGetPos($sprMech)
	Local $spr = _GEng_SpriteCreate()
	_GEng_SpriteSetImg($spr, $imgFire)
	_GEng_SpriteSet($spr, $mechPos[0] + 17, $mechPos[1] - 14, Default, Default, $GEng_Middle)
	_ArrayAdd($shots, $spr)
	$shots[0] += 1
EndFunc

Func _CheckFireAnim()
	If $shots[0] = 0 Then Return
	; ---
	Local $pos, $x, $y
	; Boucle en marche arrire pour viter que _GEng_SpriteGetPos prne comme paramtre
	; un lment du array qui fut supprim par _ArrayDelete
	For $i = $shots[0] To 1 Step -1
		$pos = _GEng_SpriteGetPos($shots[$i])
		$x = $pos[0] + 15
		$y = $pos[1]
		If $x >= 600 Then
			$shots[$i] = 0
			_ArrayDelete($shots, $i)
			$shots[0] -= 1
		ElseIf _GEng_SpriteCollision($shots[$i], $sprMech2, 0, 0, 10, 35) Then
			ConsoleWrite("Hit!" & @CRLF)
			$nbrHits += 1
			$shots[$i] = 0
			_ArrayDelete($shots, $i)
			$shots[0] -= 1
		Else
			_GEng_SpriteSet($shots[$i], $x, $y)
			_GEng_SpriteDraw($shots[$i])
		EndIf
	Next
	; ---
EndFunc

Func _exit()
	DllClose($User32_dll)
	_GEng_Shutdown()
	Exit
EndFunc
